﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace i8172W_FRNET_Modules_Csharp
{
    public partial class Form1 : Form
    {
        int slot = -1;
        ComboBox[] Type_2017_cmb = new ComboBox[16];
        ComboBox[] Type_2024_cmb = new ComboBox[4];
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            int j = 0;
            Slot_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Slot_cmb.Items.Add(string.Format("Slot {0}", i));
            }
            Port_2017_cmb.Items.Clear();
            for (i = 0; i < 4; ++i)
            {
                Port_2017_cmb.Items.Add(string.Format("Port {0}", i));
                Port_2024_cmb.Items.Add(string.Format("Port {0}", i));
                Port_2053_cmb.Items.Add(string.Format("Port {0}", i));
                Port_2054_cmb.Items.Add(string.Format("Port {0}", i));
                Port_2057_cmb.Items.Add(string.Format("Port {0}", i));
            }
            Group_2017_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Group_2017_cmb.Items.Add(string.Format("Group {0}", i));
                Group_2024_cmb.Items.Add(string.Format("Group {0}", i));
                Group_2053_cmb.Items.Add(string.Format("Group {0}", i));
                Group_2054_cmb.Items.Add(string.Format("Group {0}", i));
                Group_2057_cmb.Items.Add(string.Format("Group {0}", i));
            }
            Jumper_2017_cmb.Items.Clear();
            Jumper_2017_cmb.Items.Add("Differential");
            Jumper_2017_cmb.Items.Add("Single-Ended");
            Bit_Mode_2017_cmb.Items.Clear();
            Bit_Mode_2017_cmb.Items.Add("12-Bit");
            Bit_Mode_2017_cmb.Items.Add("16-Bit");

            Type_2017_cmb[0] = C0_Type_2017_cmb;
            Type_2017_cmb[1] = C1_Type_2017_cmb;
            Type_2017_cmb[2] = C2_Type_2017_cmb;
            Type_2017_cmb[3] = C3_Type_2017_cmb;
            Type_2017_cmb[4] = C4_Type_2017_cmb;
            Type_2017_cmb[5] = C5_Type_2017_cmb;
            Type_2017_cmb[6] = C6_Type_2017_cmb;
            Type_2017_cmb[7] = C7_Type_2017_cmb;
            Type_2017_cmb[8] = C8_Type_2017_cmb;
            Type_2017_cmb[9] = C9_Type_2017_cmb;
            Type_2017_cmb[10] = C10_Type_2017_cmb;
            Type_2017_cmb[11] = C11_Type_2017_cmb;
            Type_2017_cmb[12] = C12_Type_2017_cmb;
            Type_2017_cmb[13] = C13_Type_2017_cmb;
            Type_2017_cmb[14] = C14_Type_2017_cmb;
            Type_2017_cmb[15] = C15_Type_2017_cmb;
            for (i = 0; i < 16; ++i)
            {
                Type_2017_cmb[i].Items.Clear();
                Type_2017_cmb[i].Items.Add("[0x7]  4 ~ 20 mA");
                Type_2017_cmb[i].Items.Add("[0x8]  +/-10 V");
                Type_2017_cmb[i].Items.Add("[0x9]  +/-5 V");
                Type_2017_cmb[i].Items.Add("[0xa]  +/-1 V");
                Type_2017_cmb[i].Items.Add("[0xb]  +/-500 mV");
                Type_2017_cmb[i].Items.Add("[0xc]  +/-150 mV");
                Type_2017_cmb[i].Items.Add("[0xd]  +/-20 mA");
                Type_2017_cmb[i].Items.Add("[0x1a] 0 ~ 20 mA");
            }

            Type_2024_cmb[0] = C0_Type_2024_cmb;
            Type_2024_cmb[1] = C1_Type_2024_cmb;
            Type_2024_cmb[2] = C2_Type_2024_cmb;
            Type_2024_cmb[3] = C3_Type_2024_cmb;
            for (i = 0; i < 4; ++i)
            {
                Type_2024_cmb[i].Items.Clear();
                Type_2024_cmb[i].Items.Add("[0x30] 0 ~ 20mA");
                Type_2024_cmb[i].Items.Add("[0x31] 4 ~ 20mA");
                Type_2024_cmb[i].Items.Add("[0x32] 0V ~ +10V");
                Type_2024_cmb[i].Items.Add("[0x33] -10V ~ +10V");
                Type_2024_cmb[i].Items.Add("[0x34] 0V ~ +5V");
                Type_2024_cmb[i].Items.Add("[0x35] -5V ~ +5V");
            }
        }

        private void Slot_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = -1;
            ret = pac8172WNet.pac8172W.Init((Int16)Slot_cmb.SelectedIndex);
            if (ret == 0)
            {
                slot = Slot_cmb.SelectedIndex;
                Lib_date_txt.Text = pac8172WNet.pac8172W.LibDate();
                Lib_ver_txt.Text = pac8172WNet.pac8172W.LibVersion().ToString();
            }
            else
            {
                MessageBox.Show("I-8172W is not at slot " + Slot_cmb.SelectedIndex.ToString() + "  " + ret.ToString());
                //MessageBox.Show("I-8172W is not at slot " + Slot_cmb.SelectedIndex.ToString());
            }
        }

        private void ReadAI_btn_Click(object sender, EventArgs e)
        {
            TextBox[] txtAI = { txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            int i = 0;
            int bitMode = 0;
            int max_ch = 0;
            short typecode = 0;
            float fval = 0;
            short hval = 0;
            if (Jumper_2017_cmb.SelectedIndex == 0)
            {
                max_ch = 8;
            }
            else
            {
                max_ch = 16;
            }
            if (Bit_Mode_2017_cmb.SelectedIndex == 0)
            {
                bitMode = 12;
            }
            else
            {
                bitMode = 16;
            }
            for (i = 0; i < max_ch; ++i)
            {
                if (Type_2017_cmb[i].SelectedIndex != 7)
                {
                    typecode = (short)(Type_2017_cmb[i].SelectedIndex + 7);
                }
                else
                {
                    typecode = 0x1a;
                }
                pac8172WNet.pac8172W.ReadAI_Ch(slot, Port_2017_cmb.SelectedIndex, (Group_2017_cmb.SelectedIndex + 8), (short)bitMode, typecode, (short)i, ref fval);
                txtAI[i].Text = fval.ToString();
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void Write_AO(object sender, EventArgs e)
        {
            Int16 bitMode = 12;
            TextBox[] AO = new TextBox[] { txtAO0, txtAO1, txtAO2, txtAO3 };
            ComboBox[] type_code = { C0_Type_2024_cmb, C1_Type_2024_cmb, C2_Type_2024_cmb, C3_Type_2024_cmb };
            Int16 ch = Int16.Parse(((Button)sender).Tag.ToString());
            Int16 typeCode = (Int16)(type_code[ch].SelectedIndex + 0x30);
            pac8172WNet.pac8172W.WriteAOFloat(slot, Port_2024_cmb.SelectedIndex, Group_2024_cmb.SelectedIndex, bitMode, ch, typeCode, Convert.ToSingle(AO[ch].Text), 0);
        }

        private void Read_DI_2053_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            Label[] diBitArr = new Label[] { lbDI0, lbDI1, lbDI2, lbDI3, lbDI4, lbDI5, lbDI6, lbDI7, lbDI8, lbDI9, lbDI10, lbDI11, lbDI12, lbDI13, lbDI14, lbDI15 };
            for (i = 0; i < 16; ++i)
            {
                diBitArr[i].Text = pac8172WNet.pac8172W.ReadDIBit(slot, Port_2053_cmb.SelectedIndex, Group_2053_cmb.SelectedIndex + 8, i).ToString();
            }
        }

        private void DIO_WriteDOBit(object sender, EventArgs e)
        {
            CheckBox[] doBitArr = new CheckBox[] { ckDIO_DO0, ckDIO_DO1, ckDIO_DO2, ckDIO_DO3, ckDIO_DO4, ckDIO_DO5, ckDIO_DO6, ckDIO_DO7 };
            Int16 index = Int16.Parse(((CheckBox)sender).Tag.ToString());
            if (doBitArr[index].Checked == true)
                pac8172WNet.pac8172W.DIO_WriteDOBit(slot, Port_2054_cmb.SelectedIndex, Group_2054_cmb.SelectedIndex, index, 1);
            else
                pac8172WNet.pac8172W.DIO_WriteDOBit(slot, Port_2054_cmb.SelectedIndex, Group_2054_cmb.SelectedIndex, index, 0);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int i = 0;
            Label[] dio_diBitArr = new Label[] { lbDIO_DI0, lbDIO_DI1, lbDIO_DI2, lbDIO_DI3, lbDIO_DI4, lbDIO_DI5, lbDIO_DI6, lbDIO_DI7 };
            for (i = 0; i < 8; ++i)
            {
                dio_diBitArr[i].Text = pac8172WNet.pac8172W.ReadDIBit(slot, Port_2054_cmb.SelectedIndex, Group_2054_cmb.SelectedIndex, i).ToString();
            }
        }
        private void WriteDOBit(object sender, EventArgs e)
        {
            CheckBox[] doBitArr = new CheckBox[] { ckDO0, ckDO1, ckDO2, ckDO3, ckDO4, ckDO5, ckDO6, ckDO7, ckDO8, ckDO9, ckDO10, ckDO11, ckDO12, ckDO13, ckDO14, ckDO15 };
            Int16 index = Int16.Parse(((CheckBox)sender).Tag.ToString());
            if (doBitArr[index].Checked == true)
                pac8172WNet.pac8172W.WriteDOBit(slot, Port_2057_cmb.SelectedIndex, Group_2057_cmb.SelectedIndex, index, 1);
            else
                pac8172WNet.pac8172W.WriteDOBit(slot, Port_2057_cmb.SelectedIndex, Group_2057_cmb.SelectedIndex, index, 0);

        }
    }
}
